# Migration Complexity Estimator

The **Migration Complexity Estimator** module for Drupal provides an analysis of
entity migrations, helping site builders and developers assess the complexity of
migrating their content structures.

## 📌 Features
- **Detailed Migration Complexity Report**: Analyzes entity types, bundles, and
fields.
- **Complexity Score Calculation**: Dynamically calculates migration complexity
based on configurable weights.
- **Field Analysis**: Categorizes fields as common or uncommon across content
types.
- **Filtering Options**: UI to filter entities, bundles, and fields.
- **Admin Settings Page**: Adjust weight factors for complexity calculation.

## 🛠️ Installation

### **1. Download via Composer (Recommended)**
```sh
composer require drupal/migration_complexity_estimator
```
### **2. Manually Install**
```sh
Extract the module into:
modules/custom/migration_complexity_estimator/
```
### **3. Enable the module**
```sh
drush en migration_complexity_estimator -y
```
### 🎛️ Configuration
1. Navigate to **Administration » Reports » Migration Complexity Report**
(`/admin/reports/migration-complexity`).
2. Adjust weight values for different migration factors at
**Complexity Settings** (`/admin/reports/migration-complexity/settings`).
3. Weights are configurable from the admin UI and must sum up to 1.0:
   - Entity Types
   - Bundles
   - Fields
   - Entities
   - Entity Reference & Revision Fields
   - File & Image Fields
   - Multi-value Fields
   
  ###  📊 Usage
1. Visit Reports » Migration Complexity.
2. View migration complexity statistics, field grouping, and breakdowns.

### 🔗 Related Modules
1. Migrate: Core migration framework
2. Migrate Plus: Extends migration capabilities.
